VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Simple Demo of the use of Zipper"
   ClientHeight    =   2715
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   5760
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2715
   ScaleWidth      =   5760
   StartUpPosition =   2  'CenterScreen
   Begin ComctlLib.ProgressBar prgZip 
      Height          =   315
      Left            =   0
      TabIndex        =   5
      Top             =   2400
      Visible         =   0   'False
      Width           =   3000
      _ExtentX        =   5292
      _ExtentY        =   556
      _Version        =   327682
      Appearance      =   1
   End
   Begin ZipperDemo.Zipper Zipper 
      Left            =   420
      Top             =   1680
      _ExtentX        =   741
      _ExtentY        =   741
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Height          =   495
      Left            =   2273
      TabIndex        =   4
      Top             =   1620
      Width           =   1215
   End
   Begin VB.Label lblStatus 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   3120
      TabIndex        =   6
      Top             =   2400
      Width           =   2580
   End
   Begin VB.Label lblArchive 
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      ForeColor       =   &H80000008&
      Height          =   315
      Left            =   60
      TabIndex        =   3
      Top             =   1140
      Width           =   5595
   End
   Begin VB.Label Label2 
      Caption         =   "ZIP archive to create:"
      Height          =   255
      Left            =   60
      TabIndex        =   2
      Top             =   840
      Width           =   2655
   End
   Begin VB.Label lblFolder 
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      ForeColor       =   &H80000008&
      Height          =   315
      Left            =   60
      TabIndex        =   1
      Top             =   420
      Width           =   5595
   End
   Begin VB.Label Label1 
      Caption         =   "Folder to be ZIPped:"
      Height          =   255
      Left            =   60
      TabIndex        =   0
      Top             =   120
      Width           =   2655
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private SourceFolder As String
Private Archive As String

Private Function AddFolderToZipper(ByVal SourcePath As String, ByVal DestFolder As String) As Boolean
    'SourcePath is a full path to folder to ZIP with a trailing "\" included.
    '
    'DestFolder is a short path destination within the archive, with a
    'trailing "\" unless it is the top level where it is empty ("").
    '
    'Returns True on success.
    
    Dim SubFolders As Collection
    Dim ItemName As Variant
    Dim Success As Boolean
    
    Success = True
    Set SubFolders = New Collection
    ItemName = Dir$(SourcePath & "*.*", vbNormal Or vbReadOnly Or vbDirectory)
    Do While Len(ItemName) > 0
        If (GetAttr(SourcePath & ItemName) And vbDirectory) Then
            If Not (ItemName = "." Or ItemName = "..") Then
                SubFolders.Add ItemName
            End If
        Else
            If Zipper.AddFile(SourcePath & ItemName, DestFolder & ItemName) Then
                lblStatus.Caption = "AddFile failed on " & ItemName
                Success = False
                Exit Do
            End If
        End If
        ItemName = Dir$()
    Loop
    If Success Then
        For Each ItemName In SubFolders
            Success = AddFolderToZipper(SourcePath & ItemName & "\", ItemName & "\")
            If Not Success Then Exit For
        Next
    End If
    AddFolderToZipper = Success
End Function

Private Sub cmdGo_Click()
    cmdGo.Enabled = False
    If AddFolderToZipper(SourceFolder & "\", "") Then
        prgZip.Visible = True
        With Zipper
            If .Zip(Archive) Then
                prgZip.Visible = False
                lblStatus.Caption = "Err " & CStr(.Result) & " in " & .Failed
            End If
        End With
    End If
End Sub

Private Sub Form_Load()
    With prgZip
        .Value = 0
        .Move 0, ScaleHeight - .Height, ScaleWidth
    End With
    With lblStatus
        .Move 0, ScaleHeight - .Height, ScaleWidth
    End With
    SourceFolder = App.Path & "\DemoFolder"
    lblFolder.Caption = SourceFolder
    Archive = App.Path & "\DemoFolder.zip"
    lblArchive.Caption = Archive
    On Error Resume Next
    Kill Archive
End Sub

Private Sub Zipper_Complete(ByVal Canceled As Boolean)
    Caption = Caption & "  (Complete)"
End Sub

Private Sub Zipper_Error()
    prgZip.Visible = False
    With Zipper
        lblStatus.Caption = "Err " & CStr(.Result) & " in " & .Failed
    End With
End Sub

Private Sub Zipper_Progress()
    With Zipper
        prgZip.Value = (.BytesZipped * 100) / .BytesToZip
    End With
End Sub
